/****************************************************************************
dconv.h - Prototypes for data conversion functions

Author:  Paul Hughett

Copyright (c) 1998-2000 Trustees of the University of Pennsylvania
See the file COPYING for license terms.

This public header file contains prototypes for various functions used
within bblimage to convert between internal and external data formats,
or between external data formats used on different platforms.  They
are probably useful for applications other than bblimage as well.
****************************************************************************/

#ifndef DCONV_H
#define DCONV_H

extern void uchar_to_float (long count, float  *dest, unsigned char *src);
extern void uint2_to_float (long count, float  *dest, unsigned char *src);
extern void  int2_to_float (long count, float  *dest, unsigned char *src);
extern void  int4_to_float (long count, float  *dest, unsigned char *src);
extern void  int4_to_double(long count, double *dest, unsigned char *src);

extern void swap_bytes(long count, unsigned char *dest, unsigned char *src,
    int nbout, int nbin, int *inbyte, unsigned char *ctab);

extern void ulong_to_bytes(long count, unsigned char *dest,
    unsigned long *src, int nbytes, int bigendian);

extern void float_to_uchar(long count, unsigned char *dest, float *src);
extern void float_to_uint2(long count, unsigned char *dest, float *src);
extern void float_to_int2 (long count, unsigned char *dest, float *src);
extern void float_to_int4 (long count, unsigned char *dest, float *src);


#endif  /* DCONV_H */
