/****************************************************************************
eigen_vector.h - Header file for eigen_vector.c

Author:  Paul Hughett

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
*****************************************************************************/

#ifndef EIGEN_VECTOR_H
#define EIGEN_VECTOR_H

extern int Check_InRegion(float xi, float yj, float zk, float Low_I, 
   float Low_J, float Low_K, float Up_I, float Up_J, float Up_K);

extern void Find_CovMatrix(struct coordinate2   **B_Coordinate3P, 
   int *B_SizeP, CovMatrix_Info *InfoP, int FirstSlice, int LastSlice, 
   float Low_I, float Low_J, float Low_K, float Up_I, float Up_J, 
   float Up_K, double **RotationP, double *TranslationP);

extern void Jacobi_Rotate(double **SymMatrixP_In, int Row_r, int Col_p, 
   int Row_s, int Col_q, double sin_angle, double tau);

extern int Eigen_SymMatrix(double **SymMatrix_In, int Matrix_N, 
   double *EigenValue_Out, double **EigenVector_Out);

extern void X_2Matrix(double **Matrix1_In, double **Matrix2_In, 
   double **Matrix_Out, int N, int M, int L);

extern void T_Matrix(double **Matrix_In, double **Matrix_Out, int N, int M);


#endif /* EIGEN_VECTOR_H */
