/*****************************************************************************
find_mask.h - Prototypes for functions defined in find_mask.c 

Author:  Paul Hughett

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
******************************************************************************/

#ifndef FIND_MASK_H
#define FIND_MASK_H

extern void B_Coordinate3D (char *Name_In, int ImgType_In, char *Overlay_YN, 
   char *OuterFirst_YN, char *UpperT_YN, int SmoothOption, int TotalSlice, 
   int FirstSlice, int LastSlice, int N, int M, float Res_XY, float Res_Z, 
   struct coordinate2  ***B_Coordinate3P, int **B_SizeP);

extern int find_mask(float **Mask_In, float **Mask_Out, int N, int M, 
   char *CONTOUR_MASK);

extern int boundary_pixel(float **LabelP, struct coordinate2 *B_Coordinate, 
   int N, int M);

extern void dilate(float **InImgP, float **OutImgP, int N, int M);

extern void dilate_8(float **InImgP, float **OutImgP, int N, int M);

extern void dilate3D(unsigned char ***InImgP, unsigned char ***OutImgP, 
   int N, int M, int L);

extern void dilateLabel3D(unsigned char ***InImgP, unsigned char ***OutImgP, 
   int N, int M, int L);

extern void erode(float **InImgP, float **OutImgP, int N, int M);

extern void erode_8(float **InImgP, float **OutImgP, int N, int M);

extern void erode3D(unsigned char ***InImgP, unsigned char ***OutImgP, 
   int N, int M, int L);


#endif  /* FIND_MASK_H */
