/****************************************************************************
region_grow.h - Prototypes for functions defined in region_grow.c 

Author:  Paul Hughett

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
*****************************************************************************/

#ifndef REGION_GROW_H
#define REGION_GROW_H

int PutN_Stack3D (int i, int j, int k);
int PopN_Stack3D (int *i, int *j, int *k);
int UpdateN_Stack3D (unsigned char ***LabImg, int N, int M, int L, 
   int i, int j, int k, int CurLabel);
int FillRegion (unsigned char ***LabImg, int N, int M, int L, 
   int Si, int Sj, int Sk, int CurLabel, int NewLabel);
int ConnectComponent (unsigned char ***Binary_In, unsigned char ***Label_Out, 
   int N, int M, int L, int MinRegSize, int Target_V, int MaxRegNo, 
   int *MaxV_Label);
void TakeLabel (unsigned char ***Label_IO, unsigned char Value_I, 
   unsigned char Value_O, int N, int M, int L);
void And2Mask (unsigned char ***Label_IO, unsigned char ***Label_Ref, 
   int Value_IO, int Value_Ref, int N, int M, int L);
extern void ExtractVOI(unsigned char ***Binary_In, unsigned char ***Mask_Out, 
   int N, int M, int L, char *OuterFirst_YN);
extern void ExtractHead(unsigned char *** Binary_In, unsigned char *** Mask_Out,
   int N, int M, int L);
extern void InnerMask(unsigned char ***Binary_In, unsigned char ***Mask_IO, 
   unsigned char ***Mask_Out, int N, int M, int L);
extern void CleanUpMask(unsigned char ***Binary_IO, 
   unsigned char ***Binary_Ref, int N, int M, int L);
int MaskPropagate (unsigned char **Binary_IO, unsigned char **Mask_Ref, 
   int N, int M);
void DistMap (unsigned char ***Binary_In, unsigned char ***Map_Out, 
   int N, int M, int L);
int T_DistMap (unsigned char ***Map_In, int N, int M, int L);
void ChamferDist2D (float **Label_In, float **Map_Out, int N, int M);
int RegionGrow3D(unsigned char ***LabImg, int N, int M, int L, 
   int Si, int Sj, int Sk, int CurLabel, int NewLabel);

#endif /* REGION_GROW_H */
